<?php
    defined('_JEXEC') or die('Restricted access');
	
    class plgJshoppingShow_group_discount extends JPlugin{
		
		
		const PLG = 'show_group_discount';
		const FIELD_DISCOUNT = 'user_group_discount';
		private static $_discount = false;
			
		public function __construct(&$subject, $config = array()){
            parent::__construct($subject, $config);
			JSFactory::loadExtLanguageFile(self::PLG);
			self::initDiscountUserGroup();
        }
		
		
		public function onBeforeDisplayCartView(&$view){
			self::addHtmlInView($view);
		}		
		public function onBeforeDisplayCheckoutCartView(&$view){
			self::addHtmlInView($view);
		}
		public function onBeforeCreateTemplateOrderPartMail(&$view){
			self::addHtmlInView($view);
		}
		public function onBeforeCreateTemplateOrderMail(&$view){
			self::addHtmlInView($view);
		}
		public function onAfterCreateOrder(&$order, &$cart){
			if(self::isStep5Save()){
				$order->{self::FIELD_DISCOUNT} = self::$_discount;
				$order->store();
			}
		}
		public function onBeforeCreatePdfOrderAfterEndTotal(&$order, &$pdf, &$y){
			self::setPercentDiscount($order->{self::FIELD_DISCOUNT});
			if($text_line = self::getTextLine()){
				$pdf->SetXY(20, $y+10+7);
				$pdf->SetFont('freesans','',7);				
				$pdf->MultiCell(170,5,$text_line,'0','R');
			}
		}
		public function onBeforeDisplayOrderView(&$view){
			self::addHtmlInView($view);
		}		
		public function onBeforeShowOrder(&$view){
			self::addHtmlInView($view,5);
		}
		public function onBeforeEditOrders(&$view){
			self::setPercentDiscount($view->order->{self::FIELD_DISCOUNT});
			self::addHtmlFieldInEditView($view);
		}
		
		
		
		
		public static function addHtmlFieldInEditView(&$view){
			$view->_tmp_html_after_total .= '
				<tr class="bold">
					<td class="right">'._JSHOP_SGD_FIELD_DISCOUNT.'</td>
					<td width="20%" class="left">
						<input type="text" value="'.self::$_discount.'" name="'.self::FIELD_DISCOUNT.'" class="small3"> % 
					</td>
				</tr>
			';
		}	
		
		public static function isStep5Save(){
			$controller = JRequest::getCmd('controller');
			$task = JRequest::getCmd('task');
			return ($controller == 'checkout' && $task == 'step5save');
		}
		public static function addHtmlInView(&$view,$colspan=2){
			if(isset($view->order->{self::FIELD_DISCOUNT}))
				self::setPercentDiscount($view->order->{self::FIELD_DISCOUNT});
			$view->_tmp_html_after_total .= self::getTextLineHtmlAfterTotal($colspan);
		}		
		public static function getTextLineHtmlAfterTotal($colspan=2){			
			return ($html = self::getTextLineHtml())
				? '<tr><td colspan="'.$colspan.'">'.$html.'</td></tr>'
				: '';
		}
		public static function getTextLineHtml(){			
			return ($text_line = self::getTextLine()) 
				? '<div id="'.self::PLG.'" style="font-size:0.8em; color:#777; text-align:right;">'.$text_line.'</div>' 
				: '';
		}		
		public static function getTextLine(){
			return self::$_discount 
				? strtr(_JSHOP_SGD_INFO_LINE,array('{discount}'=>self::$_discount))
				: '';
		}		
		public static function initDiscountUserGroup(){
			$userShop = JSFactory::getUserShop();
			if($userShop->percent_discount)
				self::setPercentDiscount($userShop->percent_discount);
		}
		public static function setPercentDiscount($val){
			self::$_discount = floatval($val);
		}
		
    }
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	